GDAL

- Main Page
- Related Pages
- Classes
- Files

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions | Static Protected Member Functions | Protected Attributes | List of all members
OGRGeometryCollection Class Reference

A collection of 1 or more geometry objects. More...

`#include <ogr_geometry.h>`

Inheritance diagram for OGRGeometryCollection:

## Public Member Functions
| OGRGeometryCollection ()
| Create an empty geometry collection.
| OGRGeometryCollection (const OGRGeometryCollection &other)
| Copy constructor. More...
OGRGeometryCollection & | operator= (const OGRGeometryCollection &other)
| Assignment operator. More...
virtual const char * | getGeometryName () const
| Fetch WKT name for geometry type. More...
virtual OGRwkbGeometryType | getGeometryType () const
| Fetch geometry type. More...
virtual OGRGeometry * | clone () const
| Make a copy of this object. More...
virtual void | empty ()
| Clear geometry information. More...
virtual OGRErr | transform (OGRCoordinateTransformation *poCT)
| Apply arbitrary coordinate transformation to geometry. More...
virtual void | flattenTo2D ()
| Convert geometry to strictly 2D. More...
virtual OGRBoolean | IsEmpty () const
| Returns TRUE (non-zero) if the object has no points. More...
virtual void | segmentize (double dfMaxLength)
| Modify the geometry such it has no segment longer then the given distance. More...
virtual OGRBoolean | hasCurveGeometry (int bLookForNonLinear=FALSE) const
| Returns if this geometry is or has curve geometry. More...
virtual OGRGeometry * | getCurveGeometry (const char *const *papszOptions=NULL) const
| Return curve version of this geometry. More...
virtual OGRGeometry * | getLinearGeometry (double dfMaxAngleStepSizeDegrees=0, const char *const *papszOptions=NULL) const
| Return, possibly approximate, non-curve version of this geometry. More...
virtual int | WkbSize () const
| Returns size of related binary representation. More...
virtual OGRErr | importFromWkb (unsigned char *, int=-1, OGRwkbVariant=wkbVariantOldOgc)
| Assign geometry from well known binary data. More...
virtual OGRErr | exportToWkb (OGRwkbByteOrder, unsigned char *, OGRwkbVariant=wkbVariantOldOgc) const
| Convert a geometry into well known binary format. More...
virtual OGRErr | importFromWkt (char **)
| Assign geometry from well known text data. More...
virtual OGRErr | exportToWkt (char **ppszDstText, OGRwkbVariant=wkbVariantOldOgc) const
| Convert a geometry into well known text format. More...
virtual double | get_Length () const
| Compute the length of a multicurve. More...
virtual double | get_Area () const
| Compute area of geometry collection. More...
virtual int | getDimension () const
| Get the dimension of this object. More...
virtual void | getEnvelope (OGREnvelope *psEnvelope) const
| Computes and returns the bounding envelope for this geometry in the passed psEnvelope structure. More...
virtual void | getEnvelope (OGREnvelope3D *psEnvelope) const
| Computes and returns the bounding envelope (3D) for this geometry in the passed psEnvelope structure. More...
int | getNumGeometries () const
| Fetch number of geometries in container. More...
OGRGeometry * | getGeometryRef (int)
| Fetch geometry from container. More...
const OGRGeometry * | getGeometryRef (int) const
virtual OGRBoolean | Equals (OGRGeometry *) const
| Returns TRUE if two geometries are equivalent. More...
virtual void | setCoordinateDimension (int nDimension)
| Set the coordinate dimension. More...
virtual void | set3D (OGRBoolean bIs3D)
| Add or remove the Z coordinate dimension. More...
virtual void | setMeasured (OGRBoolean bIsMeasured)
| Add or remove the M coordinate dimension. More...
virtual OGRErr | addGeometry (const OGRGeometry *)
| Add a geometry to the container. More...
virtual OGRErr | addGeometryDirectly (OGRGeometry *)
| Add a geometry directly to the container. More...
virtual OGRErr | removeGeometry (int iIndex, int bDelete=TRUE)
| Remove a geometry from the container. More...
void | closeRings ()
| Force rings to be closed. More...
virtual void | swapXY ()
| Swap x and y coordinates. More...
Public Member Functions inherited from OGRGeometry
| OGRGeometry (const OGRGeometry &other)
| Copy constructor. More...
OGRGeometry & | operator= (const OGRGeometry &other)
| Assignment operator. More...
virtual int | getCoordinateDimension () const
| Get the dimension of the coordinates in this object. More...
int | CoordinateDimension () const
| Get the dimension of the coordinates in this object. More...
virtual OGRBoolean | IsValid () const
| Test if the geometry is valid. More...
virtual OGRBoolean | IsSimple () const
| Test if the geometry is simple. More...
OGRBoolean | Is3D () const
OGRBoolean | IsMeasured () const
virtual OGRBoolean | IsRing () const
| Test if the geometry is a ring. More...
OGRwkbGeometryType | getIsoGeometryType () const
| Get the geometry type that conforms with ISO SQL/MM Part3. More...
virtual void | dumpReadable (FILE *, const char *=NULL, char **papszOptions=NULL) const
| Dump geometry in well known text format to indicated output file. More...
virtual char * | exportToGML (const char *const *papszOptions=NULL) const
| Convert a geometry into GML format. More...
virtual char * | exportToKML () const
| Convert a geometry into KML format. More...
virtual char * | exportToJson () const
| Convert a geometry into GeoJSON format. More...
virtual GEOSGeom | exportToGEOS (GEOSContextHandle_t hGEOSCtxt) const CPL_WARN_UNUSED_RESULT
void | assignSpatialReference (OGRSpatialReference *poSR)
| Assign spatial reference to this object. More...
OGRSpatialReference * | getSpatialReference (void) const
| Returns spatial reference system for object. More...
OGRErr | transformTo (OGRSpatialReference *poSR)
| Transform geometry to new spatial reference system. More...
virtual OGRBoolean | Intersects (const OGRGeometry *) const
| Do these features intersect? More...
virtual OGRBoolean | Disjoint (const OGRGeometry *) const
| Test for disjointness. More...
virtual OGRBoolean | Touches (const OGRGeometry *) const
| Test for touching. More...
virtual OGRBoolean | Crosses (const OGRGeometry *) const
| Test for crossing. More...
virtual OGRBoolean | Within (const OGRGeometry *) const
| Test for containment. More...
virtual OGRBoolean | Contains (const OGRGeometry *) const
| Test for containment. More...
virtual OGRBoolean | Overlaps (const OGRGeometry *) const
| Test for overlap. More...
virtual OGRGeometry * | Boundary () const CPL_WARN_UNUSED_RESULT
| Compute boundary. More...
virtual double | Distance (const OGRGeometry *) const
| Compute distance between two geometries. More...
virtual OGRGeometry * | ConvexHull () const CPL_WARN_UNUSED_RESULT
| Compute convex hull. More...
virtual OGRGeometry * | Buffer (double dfDist, int nQuadSegs=30) const CPL_WARN_UNUSED_RESULT
| Compute buffer of geometry. More...
virtual OGRGeometry * | Intersection (const OGRGeometry *) const CPL_WARN_UNUSED_RESULT
| Compute intersection. More...
virtual OGRGeometry * | Union (const OGRGeometry *) const CPL_WARN_UNUSED_RESULT
| Compute union. More...
virtual OGRGeometry * | UnionCascaded () const CPL_WARN_UNUSED_RESULT
| Compute union using cascading. More...
virtual OGRGeometry * | Difference (const OGRGeometry *) const CPL_WARN_UNUSED_RESULT
| Compute difference. More...
virtual OGRGeometry * | SymDifference (const OGRGeometry *) const CPL_WARN_UNUSED_RESULT
| Compute symmetric difference. More...
virtual OGRErr | Centroid (OGRPoint *poPoint) const
| Compute the geometry centroid. More...
virtual OGRGeometry * | Simplify (double dTolerance) const CPL_WARN_UNUSED_RESULT
| Simplify the geometry. More...
OGRGeometry * | SimplifyPreserveTopology (double dTolerance) const CPL_WARN_UNUSED_RESULT
| Simplify the geometry while preserving topology. More...
virtual OGRGeometry * | DelaunayTriangulation (double dfTolerance, int bOnlyEdges) const CPL_WARN_UNUSED_RESULT
| Return a Delaunay triangulation of the vertices of the geometry. More...
virtual OGRGeometry * | Polygonize () const CPL_WARN_UNUSED_RESULT
| Polygonizes a set of sparse edges. More...
OGRBoolean | Intersect (OGRGeometry *) const CPL_WARN_DEPRECATED("Non standard method. Use Intersects() instead")
OGRBoolean | Equal (OGRGeometry *) const CPL_WARN_DEPRECATED("Non standard method. Use Equals() instead")
OGRGeometry * | SymmetricDifference (const OGRGeometry *) const CPL_WARN_DEPRECATED("Non standard method. Use SymDifference() instead")
| Compute symmetric difference (deprecated) More...
OGRGeometry * | getBoundary () const CPL_WARN_DEPRECATED("Non standard method. Use Boundary() instead")
| Compute boundary (deprecated) More...

## Protected Member Functions
OGRErr | exportToWktInternal (char **ppszDstText, OGRwkbVariant eWkbVariant, const char *pszSkipPrefix) const
virtual OGRBoolean | isCompatibleSubType (OGRwkbGeometryType) const
Protected Member Functions inherited from OGRGeometry
OGRErr | importPreambuleFromWkt (char **ppszInput, int *pbHasZ, int *pbHasM, bool *pbIsEmpty)
OGRErr | importCurveCollectionFromWkt (char **ppszInput, int bAllowEmptyComponent, int bAllowLineString, int bAllowCurve, int bAllowCompoundCurve, OGRErr(*pfnAddCurveDirectly)(OGRGeometry *poSelf, OGRCurve *poCurve))
OGRErr | importPreambuleFromWkb (unsigned char *pabyData, int nSize, OGRwkbByteOrder &eByteOrder, OGRwkbVariant eWkbVariant)
OGRErr | importPreambuleOfCollectionFromWkb (unsigned char *pabyData, int &nSize, int &nDataOffset, OGRwkbByteOrder &eByteOrder, int nMinSubGeomSize, int &nGeomCount, OGRwkbVariant eWkbVariant)
OGRErr | PointOnSurfaceInternal (OGRPoint *poPoint) const

## Static Protected Member Functions
static OGRGeometryCollection * | TransferMembersAndDestroy (OGRGeometryCollection *poSrc, OGRGeometryCollection *poDst)

## Protected Attributes
int | nGeomCount
OGRGeometry ** | papoGeoms
Protected Attributes inherited from OGRGeometry
unsigned int | flags

## Additional Inherited Members
Static Public Member Functions inherited from OGRGeometry
static GEOSContextHandle_t | createGEOSContext ()
static void | freeGEOSContext (GEOSContextHandle_t hGEOSCtxt)
static OGRGeometry * | CastToIdentity (OGRGeometry *poGeom)
static OGRGeometry * | CastToError (OGRGeometry *poGeom)
Static Public Attributes inherited from OGRGeometry
static const unsigned int | OGR_G_NOT_EMPTY_POINT = 0x1
static const unsigned int | OGR_G_3D = 0x2
static const unsigned int | OGR_G_MEASURED = 0x4
static int | bGenerate_DB2_V72_BYTE_ORDER = FALSE

## Detailed Description

A collection of 1 or more geometry objects.

All geometries must share a common spatial reference system, and Subclasses may impose additional restrictions on the contents.

## Constructor & Destructor Documentation

OGRGeometryCollection::OGRGeometryCollection | ( | const OGRGeometryCollection & | other | ) |

Copy constructor.

Note: before GDAL 2.1, only the default implementation of the constructor existed, which could be unsafe to use.

Since
  GDAL 2.1

## Member Function Documentation

OGRErr OGRGeometryCollection::addGeometry | ( | const OGRGeometry * | poNewGeom | ) |
| virtual

Add a geometry to the container.

Some subclasses of OGRGeometryCollection restrict the types of geometry that can be added, and may return an error. The passed geometry is cloned to make an internal copy.

There is no SFCOM analog to this method.

This method is the same as the C function OGR_G_AddGeometry().

Parameters

  poNewGeom | geometry to add to the container.

Returns
  OGRERR_NONE if successful, or OGRERR_UNSUPPORTED_GEOMETRY_TYPE if the geometry type is illegal for the type of geometry container.

OGRErr OGRGeometryCollection::addGeometryDirectly | ( | OGRGeometry * | poNewGeom | ) |
| virtual

Add a geometry directly to the container.

Some subclasses of OGRGeometryCollection restrict the types of geometry that can be added, and may return an error. Ownership of the passed geometry is taken by the container rather than cloning as addGeometry() does.

This method is the same as the C function OGR_G_AddGeometryDirectly().

There is no SFCOM analog to this method.

Parameters

  poNewGeom | geometry to add to the container.

Returns
  OGRERR_NONE if successful, or OGRERR_UNSUPPORTED_GEOMETRY_TYPE if the geometry type is illegal for the type of geometry container.

OGRGeometry * OGRGeometryCollection::clone | ( |  | ) | const
| virtual

Make a copy of this object.

This method relates to the SFCOM IGeometry::clone() method.

This method is the same as the C function OGR_G_Clone().

Returns
  a new object instance with the same geometry, and spatial reference system as the original.

Implements OGRGeometry.

void OGRGeometryCollection::closeRings | ( |  | ) |
| virtual

Force rings to be closed.

If this geometry, or any contained geometries has polygon rings that are not closed, they will be closed by adding the starting point at the end.

Reimplemented from OGRGeometry.

void OGRGeometryCollection::empty | ( |  | ) |
| virtual

Clear geometry information.

This restores the geometry to it's initial state after construction, and before assignment of actual geometry.

This method relates to the SFCOM IGeometry::Empty() method.

This method is the same as the C function OGR_G_Empty().

Implements OGRGeometry.

OGRBoolean OGRGeometryCollection::Equals | ( | OGRGeometry * | poOtherGeom | ) | const
| virtual

Returns TRUE if two geometries are equivalent.

This method is the same as the C function OGR_G_Equals().

Returns
  TRUE if equivalent or FALSE otherwise.

Implements OGRGeometry.

OGRErr OGRGeometryCollection::exportToWkb | ( | OGRwkbByteOrder | eByteOrder,
|  | unsigned char * | pabyData,
|  | OGRwkbVariant | eWkbVariant = `wkbVariantOldOgc`
| ) |  | const
| virtual

Convert a geometry into well known binary format.

This method relates to the SFCOM IWks::ExportToWKB() method.

This method is the same as the C function OGR_G_ExportToWkb() or OGR_G_ExportToIsoWkb(), depending on the value of eWkbVariant.

Parameters

  eByteOrder | One of wkbXDR or wkbNDR indicating MSB or LSB byte order respectively.
  pabyData | a buffer into which the binary representation is written. This buffer must be at least OGRGeometry::WkbSize() byte in size.
  eWkbVariant | What standard to use when exporting geometries with three dimensions (or more). The default wkbVariantOldOgc is the historical OGR variant. wkbVariantIso is the variant defined in ISO SQL/MM and adopted by OGC for SFSQL 1.2.

Returns
  Currently OGRERR_NONE is always returned.

Implements OGRGeometry.

OGRErr OGRGeometryCollection::exportToWkt | ( | char ** | ppszDstText,
|  | OGRwkbVariant | eWkbVariant = `wkbVariantOldOgc`
| ) |  | const
| virtual

Convert a geometry into well known text format.

This method relates to the SFCOM IWks::ExportToWKT() method.

This method is the same as the C function OGR_G_ExportToWkt().

Parameters

  ppszDstText | a text buffer is allocated by the program, and assigned to the passed pointer. After use, *ppszDstText should be freed with OGRFree().
  eWkbVariant | the specification that must be conformed too : wbkVariantOgc for old-style 99-402 extended dimension (Z) WKB types wbkVariantIso for SFSQL 1.2 and ISO SQL/MM Part 3

Returns
  Currently OGRERR_NONE is always returned.

Implements OGRGeometry.

Reimplemented in OGRMultiLineString, OGRMultiCurve, OGRMultiPoint, OGRMultiPolygon, and OGRMultiSurface.

void OGRGeometryCollection::flattenTo2D | ( |  | ) |
| virtual

Convert geometry to strictly 2D.

In a sense this converts all Z coordinates to 0.0.

This method is the same as the C function OGR_G_FlattenTo2D().

Implements OGRGeometry.

double OGRGeometryCollection::get_Area | ( |  | ) | const
| virtual

Compute area of geometry collection.

The area is computed as the sum of the areas of all members in this collection.

Note
  No warning will be issued if a member of the collection does not support the get_Area method.

Returns
  computed area.

double OGRGeometryCollection::get_Length | ( |  | ) | const
| virtual

Compute the length of a multicurve.

The length is computed as the sum of the length of all members in this collection.

Note
  No warning will be issued if a member of the collection does not support the get_Length method.

Returns
  computed area.

OGRGeometry * OGRGeometryCollection::getCurveGeometry | ( | const char *const * | papszOptions = `NULL` | ) | const
| virtual

Return curve version of this geometry.

Returns a geometry that has possibly CIRCULARSTRING, COMPOUNDCURVE, CURVEPOLYGON, MULTICURVE or MULTISURFACE in it, by de-approximating curve geometries.

If the geometry has no curve portion, the returned geometry will be a clone of it.

The ownership of the returned geometry belongs to the caller.

The reverse method is OGRGeometry::getLinearGeometry().

This function is the same as C function OGR_G_GetCurveGeometry().

Parameters

  papszOptions | options as a null-terminated list of strings. Unused for now. Must be set to NULL.

Returns
  a new geometry.

Since
  GDAL 2.0

Reimplemented from OGRGeometry.

int OGRGeometryCollection::getDimension | ( |  | ) | const
| virtual

Get the dimension of this object.

This method corresponds to the SFCOM IGeometry::GetDimension() method. It indicates the dimension of the object, but does not indicate the dimension of the underlying space (as indicated by OGRGeometry::getCoordinateDimension()).

This method is the same as the C function OGR_G_GetDimension().

Returns
  0 for points, 1 for lines and 2 for surfaces.

Implements OGRGeometry.

Reimplemented in OGRMultiCurve, OGRMultiPoint, and OGRMultiSurface.

void OGRGeometryCollection::getEnvelope | ( | OGREnvelope * | psEnvelope | ) | const
| virtual

Computes and returns the bounding envelope for this geometry in the passed psEnvelope structure.

This method is the same as the C function OGR_G_GetEnvelope().

Parameters

  psEnvelope | the structure in which to place the results.

Implements OGRGeometry.

void OGRGeometryCollection::getEnvelope | ( | OGREnvelope3D * | psEnvelope | ) | const
| virtual

Computes and returns the bounding envelope (3D) for this geometry in the passed psEnvelope structure.

This method is the same as the C function OGR_G_GetEnvelope3D().

Parameters

  psEnvelope | the structure in which to place the results.

Since
  OGR 1.9.0

Implements OGRGeometry.

const char * OGRGeometryCollection::getGeometryName | ( |  | ) | const
| virtual

Fetch WKT name for geometry type.

There is no SFCOM analog to this method.

This method is the same as the C function OGR_G_GetGeometryName().

Returns
  name used for this geometry type in well known text format. The returned pointer is to a static internal string and should not be modified or freed.

Implements OGRGeometry.

Reimplemented in OGRMultiLineString, OGRMultiCurve, OGRMultiPoint, OGRMultiPolygon, and OGRMultiSurface.

OGRGeometry * OGRGeometryCollection::getGeometryRef | ( | int | i | ) |

Fetch geometry from container.

This method returns a pointer to an geometry within the container. The returned geometry remains owned by the container, and should not be modified. The pointer is only valid until the next change to the geometry container. Use IGeometry::clone() to make a copy.

This method relates to the SFCOM IGeometryCollection::get_Geometry() method.

Parameters

  i | the index of the geometry to fetch, between 0 and getNumGeometries() - 1.

Returns
  pointer to requested geometry.

OGRwkbGeometryType OGRGeometryCollection::getGeometryType | ( |  | ) | const
| virtual

Fetch geometry type.

Note that the geometry type may include the 2.5D flag. To get a 2D flattened version of the geometry type apply the wkbFlatten() macro to the return result.

This method is the same as the C function OGR_G_GetGeometryType().

Returns
  the geometry type code.

Implements OGRGeometry.

Reimplemented in OGRMultiLineString, OGRMultiCurve, OGRMultiPoint, OGRMultiPolygon, and OGRMultiSurface.

OGRGeometry * OGRGeometryCollection::getLinearGeometry | ( | double | dfMaxAngleStepSizeDegrees = `0`,
|  | const char *const * | papszOptions = `NULL`
| ) |  | const
| virtual

Return, possibly approximate, non-curve version of this geometry.

Returns a geometry that has no CIRCULARSTRING, COMPOUNDCURVE, CURVEPOLYGON, MULTICURVE or MULTISURFACE in it, by approximating curve geometries.

The ownership of the returned geometry belongs to the caller.

The reverse method is OGRGeometry::getCurveGeometry().

This method is the same as the C function OGR_G_GetLinearGeometry().

Parameters

  dfMaxAngleStepSizeDegrees | the largest step in degrees along the arc, zero to use the default setting.
  papszOptions | options as a null-terminated list of strings. See OGRGeometryFactory::curveToLineString() for valid options.

Returns
  a new geometry.

Since
  GDAL 2.0

Reimplemented from OGRGeometry.

int OGRGeometryCollection::getNumGeometries | ( |  | ) | const

Fetch number of geometries in container.

This method relates to the SFCOM IGeometryCollect::get_NumGeometries() method.

Returns
  count of children geometries. May be zero.

OGRBoolean OGRGeometryCollection::hasCurveGeometry | ( | int | bLookForNonLinear = `FALSE` | ) | const
| virtual

Returns if this geometry is or has curve geometry.

Returns if a geometry is, contains or may contain a CIRCULARSTRING, COMPOUNDCURVE, CURVEPOLYGON, MULTICURVE or MULTISURFACE.

If bLookForNonLinear is set to TRUE, it will be actually looked if the geometry or its subgeometries are or contain a non-linear geometry in them. In which case, if the method returns TRUE, it means that getLinearGeometry() would return an approximate version of the geometry. Otherwise, getLinearGeometry() would do a conversion, but with just converting container type, like COMPOUNDCURVE -> LINESTRING, MULTICURVE -> MULTILINESTRING or MULTISURFACE -> MULTIPOLYGON, resulting in a "loss-less" conversion.

This method is the same as the C function OGR_G_HasCurveGeometry().

Parameters

  bLookForNonLinear | set it to TRUE to check if the geometry is or contains a CIRCULARSTRING.

Returns
  TRUE if this geometry is or has curve geometry.

Since
  GDAL 2.0

Reimplemented from OGRGeometry.

Reimplemented in OGRMultiLineString, OGRMultiCurve, OGRMultiPoint, OGRMultiPolygon, and OGRMultiSurface.

OGRErr OGRGeometryCollection::importFromWkb | ( | unsigned char * | pabyData,
|  | int | nSize = `-1`,
|  | OGRwkbVariant | eWkbVariant = `wkbVariantOldOgc`
| ) |  |
| virtual

Assign geometry from well known binary data.

The object must have already been instantiated as the correct derived type of geometry object to match the binaries type. This method is used by the OGRGeometryFactory class, but not normally called by application code.

This method relates to the SFCOM IWks::ImportFromWKB() method.

This method is the same as the C function OGR_G_ImportFromWkb().

Parameters

  pabyData | the binary input data.
  nSize | the size of pabyData in bytes, or zero if not known.
  eWkbVariant | if wkbVariantPostGIS1, special interpretation is done for curve geometries code

Returns
  OGRERR_NONE if all goes well, otherwise any of OGRERR_NOT_ENOUGH_DATA, OGRERR_UNSUPPORTED_GEOMETRY_TYPE, or OGRERR_CORRUPT_DATA may be returned.

Implements OGRGeometry.

OGRErr OGRGeometryCollection::importFromWkt | ( | char ** | ppszInput | ) |
| virtual

Assign geometry from well known text data.

The object must have already been instantiated as the correct derived type of geometry object to match the text type. This method is used by the OGRGeometryFactory class, but not normally called by application code.

This method relates to the SFCOM IWks::ImportFromWKT() method.

This method is the same as the C function OGR_G_ImportFromWkt().

Parameters

  ppszInput | pointer to a pointer to the source text. The pointer is updated to pointer after the consumed text.

Returns
  OGRERR_NONE if all goes well, otherwise any of OGRERR_NOT_ENOUGH_DATA, OGRERR_UNSUPPORTED_GEOMETRY_TYPE, or OGRERR_CORRUPT_DATA may be returned.

Implements OGRGeometry.

Reimplemented in OGRMultiCurve, OGRMultiPoint, and OGRMultiSurface.

OGRBoolean OGRGeometryCollection::IsEmpty | ( |  | ) | const
| virtual

Returns TRUE (non-zero) if the object has no points.

Normally this returns FALSE except between when an object is instantiated and points have been assigned.

This method relates to the SFCOM IGeometry::IsEmpty() method.

Returns
  TRUE if object is empty, otherwise FALSE.

Reimplemented from OGRGeometry.

OGRGeometryCollection & OGRGeometryCollection::operator= | ( | const OGRGeometryCollection & | other | ) |

Assignment operator.

Note: before GDAL 2.1, only the default implementation of the operator existed, which could be unsafe to use.

Since
  GDAL 2.1

OGRErr OGRGeometryCollection::removeGeometry | ( | int | iGeom,
|  | int | bDelete = `TRUE`
| ) |  |
| virtual

Remove a geometry from the container.

Removing a geometry will cause the geometry count to drop by one, and all "higher" geometries will shuffle down one in index.

There is no SFCOM analog to this method.

This method is the same as the C function OGR_G_RemoveGeometry().

Parameters

  iGeom | the index of the geometry to delete. A value of -1 is a special flag meaning that all geometries should be removed.
  bDelete | if TRUE the geometry will be deallocated, otherwise it will not. The default is TRUE as the container is considered to own the geometries in it.

Returns
  OGRERR_NONE if successful, or OGRERR_FAILURE if the index is out of range.

void OGRGeometryCollection::segmentize | ( | double | dfMaxLength | ) |
| virtual

Modify the geometry such it has no segment longer then the given distance.

Add intermediate vertices to a geometry.

Interpolated points will have Z and M values (if needed) set to 0. Distance computation is performed in 2d only

This function is the same as the C function OGR_G_Segmentize()

Parameters

  dfMaxLength | the maximum distance between 2 points after segmentization

This method modifies the geometry to add intermediate vertices if necessary so that the maximum length between 2 consecutive vertices is lower than dfMaxLength.

Parameters

  dfMaxLength | maximum length between 2 consecutive vertices.

Reimplemented from OGRGeometry.

void OGRGeometryCollection::set3D | ( | OGRBoolean | bIs3D | ) |
| virtual

Add or remove the Z coordinate dimension.

This method adds or removes the explicit Z coordinate dimension. Removing the Z coordinate dimension of a geometry will remove any existing Z values. Adding the Z dimension to a geometry collection, a compound curve, a polygon, etc. will affect the children geometries.

Parameters

  bIs3D | Should the geometry have a Z dimension, either TRUE or FALSE.

Since
  GDAL 2.1

Reimplemented from OGRGeometry.

void OGRGeometryCollection::setCoordinateDimension | ( | int | nNewDimension | ) |
| virtual

Set the coordinate dimension.

This method sets the explicit coordinate dimension. Setting the coordinate dimension of a geometry to 2 should zero out any existing Z values. Setting the dimension of a geometry collection, a compound curve, a polygon, etc. will affect the children geometries. This will also remove the M dimension if present before this call.

Deprecated:
  use set3D() or setMeasured().

Parameters

  nNewDimension | New coordinate dimension value, either 2 or 3.

Reimplemented from OGRGeometry.

void OGRGeometryCollection::setMeasured | ( | OGRBoolean | bIsMeasured | ) |
| virtual

Add or remove the M coordinate dimension.

This method adds or removes the explicit M coordinate dimension. Removing the M coordinate dimension of a geometry will remove any existing M values. Adding the M dimension to a geometry collection, a compound curve, a polygon, etc. will affect the children geometries.

Parameters

  bIsMeasured | Should the geometry have a M dimension, either TRUE or FALSE.

Since
  GDAL 2.1

Reimplemented from OGRGeometry.

void OGRGeometryCollection::swapXY | ( |  | ) |
| virtual

Swap x and y coordinates.

Since
  OGR 1.8.0

Reimplemented from OGRGeometry.

OGRErr OGRGeometryCollection::transform | ( | OGRCoordinateTransformation * | poCT | ) |
| virtual

Apply arbitrary coordinate transformation to geometry.

This method will transform the coordinates of a geometry from their current spatial reference system to a new target spatial reference system. Normally this means reprojecting the vectors, but it could include datum shifts, and changes of units.

Note that this method does not require that the geometry already have a spatial reference system. It will be assumed that they can be treated as having the source spatial reference system of the OGRCoordinateTransformation object, and the actual SRS of the geometry will be ignored. On successful completion the output OGRSpatialReference of the OGRCoordinateTransformation will be assigned to the geometry.

This method is the same as the C function OGR_G_Transform().

Parameters

  poCT | the transformation to apply.

Returns
  OGRERR_NONE on success or an error code.

Implements OGRGeometry.

int OGRGeometryCollection::WkbSize | ( |  | ) | const
| virtual

Returns size of related binary representation.

This method returns the exact number of bytes required to hold the well known binary representation of this geometry object. Its computation may be slightly expensive for complex geometries.

This method relates to the SFCOM IWks::WkbSize() method.

This method is the same as the C function OGR_G_WkbSize().

Returns
  size of binary representation in bytes.

Implements OGRGeometry.

The documentation for this class was generated from the following files:

- ogr_geometry.h
- ogrgeometrycollection.cpp

Generated for GDAL by 1.8.8.